;**********************************
;  This file is part of
; "Simple SEGA Master System BIOS" 
;  By David Senabre Albujer.
;
;  RAM routines to acess cartridge
;
; Assembler: WLA_DX
;**********************************
    ;===============================
    ; rutinas que se copian a RAM
    ; para acceder al cartucho
    ;===============================

.section "Ram code" free
ReadCart:
/*ld a,($7FF0)
ld (String1),a
ld a,($7FF1)
ld (String1+1),a
ld a,($7FF2)
ld (String1+2),a
ld a,($7FF3)
ld (String1+3),a
ld a,($7FF4)
ld (String1+4),a
ld a,($7FF5)
ld (String1+5),a
ld a,($7FF6)
ld (String1+6),a
ld a,($7FF7)
ld (String1+7),a
ld a,($7FF8)
ld (String1+8),a */

; equivalent do:
ld de,String1
ld hl,$7FF0
ld bc,8
ldir
ret

;-------------------------------------------------
RunCart:
call CheckCart
ld a,(CartIn)
cp 1
ret nz             ;if not Cart In, go out

ld de,$C700
ld hl,RunCartStart
ld bc,RunCartEnd - RunCartStart
ldir
jp $C700

RunCartStart:
  ld a,%10101000
  out ($3E),a
  jp $0000

RunCartEnd:
.ends

;-------------------------------------------------

.section "Check Cart In" free
CheckCart:
ld de,$C700
ld hl,CheckCartStart
ld bc,CheckCartEnd - CheckCartStart
ldir
call $C700
;see if cart detected
  ld a,(String1+4)
  cp $53
  jp nz,+
  ld a,(String1+5)
  cp $45
  jp nz,+
  ld a,(String1+6)
  cp $47
  jp nz,+
  ld a,(String1+7)
  cp $41
  jp nz,+
  ld a,1
  jp ++
+:
  ld a,0
++:
  ld (GameIn),a

  ;chequear si hay cartucho
    ld     hl,String2      ; look at ROM from $0000
    ld     bc,$003c        ; loop 256 times, mask $3c
    ld     a,(hl)          ; get byte
    and    c               ; and with $3c = %00111100
    ld     e,a             ; store in e
 -:
    ld     a,(hl)          ; get byte
    inc    l               ; pointer++
    and    c               ; and with $3c
    cp     e               ; compare to first byte
    jp     nz,+            ; if not equal, cart found
    dec    b
    ld     a,b
    cp     0
    jp nz,-                ; repeat 256 times
    ld a,0                 ;redundante, a ya era 0
    ld (CartIn),a
    ret
+:
  ld a,1
  ld (CartIn),a
ret

;00007ff0h: 54 4D 52 20 53 45 47 41                         ; TMR SEGA

;-------------------------------------------------

CheckCartStart:
  ld a,%10101000
  out ($3E),a      ;enable cart, disable BIOS
  ld de,String1    ;attempt to read TRM SEGA
  ld hl,$7FF0
  ld bc,8
  ldir

  ld de,String2    ;attempt to read 256 bytes at $0000
  ld hl,$0
  ld bc,256
  ldir

  ld a,%11100000
  out ($3E),a      ;enable BIOS
  ret
CheckCartEnd:

.ends